#!/usr/bin/wish8.4
# $Id: temp.tcl,v 1.1.1.1 2006/08/21 11:19:57 harry Exp $

load ./tkImageLoad.so

image create photo master
image create photo view

canvas .c -bg white
entry .min -textvariable ::min
entry .max -textvariable ::max
button .prev -text < -command prev -state disabled
button .next -text > -command next
grid .c - -sticky nswe
grid .min .max -sticky we
grid .prev .next -sticky we
grid rowconfigure . 0 -weight 1
grid columnconfigure . { 0 1 } -weight 1

.c create image 0 0 -image view -anchor nw

set ::min 0
set ::max 0
set ::num 1


proc load {  } {
    #set i1 [time {set ::histo [imageLoad "ADSC" /home/geoff/xrays/vamp1/vamp1_2_[format %03u $::num].img master $::min $::max]}]
    set i1 [time {set ::histo [imageLoad "ADSC" /home/geoff/xrays/misc/x1_F1fms_3_001.img master $::min $::max]}]
    set i2 [time {view copy master -subsample 4 4}]
    set i3 [time {imageTranspose view}]
    puts "Creating master image:  [format %.3f [expr [lindex [split $i1] 0] / 1000000.0]]"
    puts "Copying view image:     [format %.3f [expr [lindex [split $i2] 0] / 1000000.0]]"
    puts "Transposing view image: [format %.3f [expr [lindex [split $i3] 0] / 1000000.0]]"
    puts "Total:                  [format %.3f [expr ([lindex [split $i1] 0] + [lindex [split $i2] 0] + [lindex [split $i3] 0]) / 1000000.0]]"
    puts ""
}

proc prev { } {
    incr ::num -1
    if {$::num == 1} {
	.prev configure -state disabled
    }
    .next configure -state normal
    load
}

proc next { } {
    incr ::num +1
    if {$::num == 180} {
	.next configure -state disabled
    }
    .prev configure -state normal
    load
}

load
.c configure -width [image width view] -height [image height view]

